PR target/65871
[official-gcc.git] / libgo / mksysinfo.sh
blobc2e7c24974a603c77ef0bb7397c4984a35b2f553
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This relies on a
11 # hook in gcc: the -fdump-go-spec option will generate debugging
12 # information in Go syntax.
14 # We currently #include all the files at once, which works, but leads
15 # to exposing some names which ideally should not be exposed, as they
16 # match grep patterns. E.g., WCHAR_MIN gets exposed because it starts
17 # with W, like the wait flags.
19 CC=${CC:-gcc}
20 OUT=tmp-sysinfo.go
22 set -e
24 rm -f sysinfo.c
25 cat > sysinfo.c <<EOF
26 #include "config.h"
28 #include <sys/types.h>
29 #include <dirent.h>
30 #include <errno.h>
31 #include <fcntl.h>
32 #include <netinet/in.h>
33 /* <netinet/tcp.h> needs u_char/u_short, but <sys/bsd_types> is only
34 included by <netinet/in.h> if _SGIAPI (i.e. _SGI_SOURCE
35 && !_XOPEN_SOURCE.
36 <sys/termios.h> only defines TIOCNOTTY if !_XOPEN_SOURCE, while
37 <sys/ttold.h> does so unconditionally. */
38 #ifdef __sgi__
39 #include <sys/bsd_types.h>
40 #include <sys/ttold.h>
41 #endif
42 #include <netinet/tcp.h>
43 #if defined(HAVE_NETINET_IN_SYSTM_H)
44 #include <netinet/in_systm.h>
45 #endif
46 #if defined(HAVE_NETINET_IP_H)
47 #include <netinet/ip.h>
48 #endif
49 #if defined(HAVE_NETINET_IP_MROUTE_H)
50 #include <netinet/ip_mroute.h>
51 #endif
52 #if defined(HAVE_NETINET_IF_ETHER_H)
53 #include <netinet/if_ether.h>
54 #endif
55 #include <signal.h>
56 #include <sys/ioctl.h>
57 #include <termios.h>
58 #if defined(HAVE_SYSCALL_H)
59 #include <syscall.h>
60 #endif
61 #if defined(HAVE_SYS_SYSCALL_H)
62 #include <sys/syscall.h>
63 #endif
64 #if defined(HAVE_SYS_EPOLL_H)
65 #include <sys/epoll.h>
66 #endif
67 #if defined(HAVE_SYS_FILE_H)
68 #include <sys/file.h>
69 #endif
70 #if defined(HAVE_SYS_MMAN_H)
71 #include <sys/mman.h>
72 #endif
73 #if defined(HAVE_SYS_PRCTL_H)
74 #include <sys/prctl.h>
75 #endif
76 #if defined(HAVE_SYS_PTRACE_H)
77 #include <sys/ptrace.h>
78 #endif
79 #include <sys/resource.h>
80 #include <sys/uio.h>
81 #include <sys/socket.h>
82 #include <sys/stat.h>
83 #include <sys/time.h>
84 #include <sys/times.h>
85 #include <sys/wait.h>
86 #include <sys/un.h>
87 #if defined(HAVE_SYS_USER_H)
88 #include <sys/user.h>
89 #endif
90 #if defined(HAVE_SYS_UTSNAME_H)
91 #include <sys/utsname.h>
92 #endif
93 #if defined(HAVE_SYS_SELECT_H)
94 #include <sys/select.h>
95 #endif
96 #include <time.h>
97 #include <unistd.h>
98 #include <netdb.h>
99 #include <pwd.h>
100 #if defined(HAVE_LINUX_FILTER_H)
101 #include <linux/filter.h>
102 #endif
103 #if defined(HAVE_LINUX_IF_ADDR_H)
104 #include <linux/if_addr.h>
105 #endif
106 #if defined(HAVE_LINUX_IF_ETHER_H)
107 #include <linux/if_ether.h>
108 #endif
109 #if defined(HAVE_LINUX_IF_TUN_H)
110 #include <linux/if_tun.h>
111 #endif
112 #if defined(HAVE_LINUX_NETLINK_H)
113 #include <linux/netlink.h>
114 #endif
115 #if defined(HAVE_LINUX_RTNETLINK_H)
116 #include <linux/rtnetlink.h>
117 #endif
118 #if defined(HAVE_NET_IF_H)
119 #include <net/if.h>
120 #endif
121 #if defined(HAVE_NET_IF_ARP_H)
122 #include <net/if_arp.h>
123 #endif
124 #if defined(HAVE_NET_ROUTE_H)
125 #include <net/route.h>
126 #endif
127 #if defined (HAVE_NETPACKET_PACKET_H)
128 #include <netpacket/packet.h>
129 #endif
130 #if defined(HAVE_SYS_MOUNT_H)
131 #include <sys/mount.h>
132 #endif
133 #if defined(HAVE_SYS_VFS_H)
134 #include <sys/vfs.h>
135 #endif
136 #if defined(HAVE_STATFS_H)
137 #include <sys/statfs.h>
138 #endif
139 #if defined(HAVE_SYS_TIMEX_H)
140 #include <sys/timex.h>
141 #endif
142 #if defined(HAVE_SYS_SYSINFO_H)
143 #include <sys/sysinfo.h>
144 #endif
145 #if defined(HAVE_USTAT_H)
146 #include <ustat.h>
147 #endif
148 #if defined(HAVE_UTIME_H)
149 #include <utime.h>
150 #endif
151 #if defined(HAVE_LINUX_ETHER_H)
152 #include <linux/ether.h>
153 #endif
154 #if defined(HAVE_LINUX_FS_H)
155 #include <linux/fs.h>
156 #endif
157 #if defined(HAVE_LINUX_REBOOT_H)
158 #include <linux/reboot.h>
159 #endif
160 #if defined(HAVE_SYS_INOTIFY_H)
161 #include <sys/inotify.h>
162 #endif
163 #if defined(HAVE_NETINET_ICMP6_H)
164 #include <netinet/icmp6.h>
165 #endif
166 #if defined(HAVE_SCHED_H)
167 #include <sched.h>
168 #endif
170 /* Constants that may only be defined as expressions on some systems,
171 expressions too complex for -fdump-go-spec to handle. These are
172 handled specially below. */
173 enum {
174 #ifdef TIOCGWINSZ
175 TIOCGWINSZ_val = TIOCGWINSZ,
176 #endif
177 #ifdef TIOCSWINSZ
178 TIOCSWINSZ_val = TIOCSWINSZ,
179 #endif
180 #ifdef TIOCNOTTY
181 TIOCNOTTY_val = TIOCNOTTY,
182 #endif
183 #ifdef TIOCSCTTY
184 TIOCSCTTY_val = TIOCSCTTY,
185 #endif
186 #ifdef TIOCGPTN
187 TIOCGPTN_val = TIOCGPTN,
188 #endif
189 #ifdef TIOCSPTLCK
190 TIOCSPTLCK_val = TIOCSPTLCK,
191 #endif
192 #ifdef TIOCGDEV
193 TIOCGDEV_val = TIOCGDEV,
194 #endif
195 #ifdef TIOCSIG
196 TIOCSIG_val = TIOCSIG,
197 #endif
198 #ifdef TCGETS
199 TCGETS_val = TCGETS,
200 #endif
201 #ifdef TCSETS
202 TCSETS_val = TCSETS,
203 #endif
207 ${CC} -fdump-go-spec=gen-sysinfo.go -std=gnu99 -S -o sysinfo.s sysinfo.c
209 echo 'package syscall' > ${OUT}
210 echo 'import "unsafe"' >> ${OUT}
211 echo 'type _ unsafe.Pointer' >> ${OUT}
213 # Get all the consts and types, skipping ones which could not be
214 # represented in Go and ones which we need to rewrite. We also skip
215 # function declarations, as we don't need them here. All the symbols
216 # will all have a leading underscore.
217 grep -v '^// ' gen-sysinfo.go | \
218 grep -v '^func' | \
219 grep -v '^type _timeval ' | \
220 grep -v '^type _timespec_t ' | \
221 grep -v '^type _timespec ' | \
222 grep -v '^type _timestruc_t ' | \
223 grep -v '^type _epoll_' | \
224 grep -v 'in6_addr' | \
225 grep -v 'sockaddr_in6' | \
226 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
227 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
228 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
229 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
230 >> ${OUT}
232 # The errno constants. These get type Errno.
233 echo '#include <errno.h>' | ${CC} -x c - -E -dM | \
234 egrep '#define E[A-Z0-9_]+ ' | \
235 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
237 # The O_xxx flags.
238 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
239 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
240 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
241 echo "const O_ASYNC = 0" >> ${OUT}
243 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
244 echo "const O_CLOEXEC = 0" >> ${OUT}
247 # The os package requires F_DUPFD_CLOEXEC to be defined.
248 if ! grep '^const F_DUPFD_CLOEXEC' ${OUT} >/dev/null 2>&1; then
249 echo "const F_DUPFD_CLOEXEC = 0" >> ${OUT}
252 # These flags can be lost on i386 GNU/Linux when using
253 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
254 # before we see the definition of F_SETLK64.
255 for flag in F_GETLK F_SETLK F_SETLKW; do
256 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
257 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
258 echo "const ${flag} = ${flag}64" >> ${OUT}
260 done
262 # The Flock_t struct for fcntl.
263 grep '^type _flock ' gen-sysinfo.go | \
264 sed -e 's/type _flock/type Flock_t/' \
265 -e 's/l_type/Type/' \
266 -e 's/l_whence/Whence/' \
267 -e 's/l_start/Start/' \
268 -e 's/l_len/Len/' \
269 -e 's/l_pid/Pid/' \
270 >> ${OUT}
272 # The signal numbers.
273 grep '^const _SIG[^_]' gen-sysinfo.go | \
274 grep -v '^const _SIGEV_' | \
275 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
276 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
277 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
278 echo "const SIGPOLL = SIGIO" >> ${OUT}
281 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
282 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
283 echo "const SIGCLD = SIGCHLD" >> ${OUT}
287 # The syscall numbers. We force the names to upper case.
288 grep '^const _SYS_' gen-sysinfo.go | \
289 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
290 while read sys; do
291 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
292 echo "const $sup = _$sys" >> ${OUT}
293 done
295 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
296 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
297 echo "const SYS_GETDENTS = 0" >> ${OUT}
299 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
300 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
303 # Stat constants.
304 grep '^const _S_' gen-sysinfo.go | \
305 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
307 # Mmap constants.
308 grep '^const _PROT_' gen-sysinfo.go | \
309 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
310 grep '^const _MAP_' gen-sysinfo.go | \
311 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
312 grep '^const _MADV_' gen-sysinfo.go | \
313 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
314 grep '^const _MCL_' gen-sysinfo.go | \
315 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
317 # Process status constants.
318 grep '^const _W' gen-sysinfo.go |
319 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
320 # WSTOPPED was introduced in glibc 2.3.4.
321 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
322 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
323 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
324 else
325 echo 'const WSTOPPED = 2' >> ${OUT}
328 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
329 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
330 echo 'const WALL = ___WALL' >> ${OUT}
333 # Networking constants.
334 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
335 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
336 grep '^const _SOMAXCONN' gen-sysinfo.go |
337 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
338 >> ${OUT}
339 grep '^const _SHUT_' gen-sysinfo.go |
340 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
342 # The net package requires some const definitions.
343 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
344 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
345 echo "const $m = 0" >> ${OUT}
347 done
348 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
349 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
350 echo "const $m = -1" >> ${OUT}
352 done
354 # The syscall package requires AF_LOCAL.
355 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
356 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
357 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
361 # pathconf constants.
362 grep '^const __PC' gen-sysinfo.go |
363 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
365 # The PATH_MAX constant.
366 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
367 echo 'const PathMax = _PATH_MAX' >> ${OUT}
370 # epoll constants.
371 grep '^const _EPOLL' gen-sysinfo.go |
372 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
373 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
374 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
375 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
377 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
378 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
381 # Prctl constants.
382 grep '^const _PR_' gen-sysinfo.go |
383 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
385 # Ptrace constants.
386 grep '^const _PTRACE' gen-sysinfo.go |
387 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
388 # We need some ptrace options that are not defined in older versions
389 # of glibc.
390 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
391 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
393 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
394 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
396 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
397 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
399 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
400 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
402 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
403 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
405 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
406 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
408 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
409 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
411 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
412 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
414 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
415 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
417 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
418 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
420 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
421 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
423 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
424 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
426 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
427 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
429 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
430 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
432 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
433 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
435 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
436 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
438 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
439 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
442 # A helper function that prints a structure from gen-sysinfo.go with the first
443 # letter of the field names in upper case. $1 is the name of structure. If $2
444 # is not empty, the structure or type is renamed to $2.
445 upcase_fields () {
446 name="$1"
447 def=`grep "^type $name" gen-sysinfo.go`
448 fields=`echo $def | sed -e 's/^[^{]*{\(.*\)}$/\1/'`
449 prefix=`echo $def | sed -e 's/{.*//'`
450 if test "$2" != ""; then
451 prefix=`echo $prefix | sed -e "s/$1/$2/"`
453 if test "$fields" != ""; then
454 nfields=
455 while test -n "$fields"; do
456 field=`echo $fields | sed -e 's/^\([^;]*\);.*$/\1/'`
457 fields=`echo $fields | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
458 # capitalize the next character.
459 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
460 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
461 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
462 field="$f$r"
463 nfields="$nfields $field;"
464 done
465 echo "${prefix} {$nfields }"
469 # The registers returned by PTRACE_GETREGS. This is probably
470 # GNU/Linux specific; it should do no harm if there is no
471 # _user_regs_struct.
472 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
473 if test "$regs" == ""; then
474 # s390
475 regs=`grep '^type __user_regs_struct struct' gen-sysinfo.go || true`
476 if test "$regs" != ""; then
477 # Substructures of __user_regs_struct on s390
478 upcase_fields "__user_psw_struct" "PtracePsw" >> ${OUT} || true
479 upcase_fields "__user_fpregs_struct" "PtraceFpregs" >> ${OUT} || true
480 upcase_fields "__user_per_struct" "PtracePer" >> ${OUT} || true
483 if test "$regs" != ""; then
484 regs=`echo $regs |
485 sed -e 's/type __*user_regs_struct struct //' -e 's/[{}]//g'`
486 regs=`echo $regs | sed -e s'/^ *//'`
487 nregs=
488 while test -n "$regs"; do
489 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
490 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
491 # Capitalize the first character of the field.
492 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
493 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
494 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
495 field="$f$r"
496 field=`echo "$field" | sed \
497 -e 's/__user_psw_struct/PtracePsw/' \
498 -e 's/__user_fpregs_struct/PtraceFpregs/' \
499 -e 's/__user_per_struct/PtracePer/'`
500 nregs="$nregs $field;"
501 done
502 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
505 # Some basic types.
506 echo 'type Size_t _size_t' >> ${OUT}
507 echo "type Ssize_t _ssize_t" >> ${OUT}
508 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
509 echo "type Offset_t _off64_t" >> ${OUT}
510 else
511 echo "type Offset_t _off_t" >> ${OUT}
513 echo "type Mode_t _mode_t" >> ${OUT}
514 echo "type Pid_t _pid_t" >> ${OUT}
515 echo "type Uid_t _uid_t" >> ${OUT}
516 echo "type Gid_t _gid_t" >> ${OUT}
517 echo "type Socklen_t _socklen_t" >> ${OUT}
519 # The C int type.
520 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
521 if test "$sizeof_int" = "4"; then
522 echo "type _C_int int32" >> ${OUT}
523 echo "type _C_uint uint32" >> ${OUT}
524 elif test "$sizeof_int" = "8"; then
525 echo "type _C_int int64" >> ${OUT}
526 echo "type _C_uint uint64" >> ${OUT}
527 else
528 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
529 exit 1
532 # The C long type, needed because that is the type that ptrace returns.
533 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
534 if test "$sizeof_long" = "4"; then
535 echo "type _C_long int32" >> ${OUT}
536 elif test "$sizeof_long" = "8"; then
537 echo "type _C_long int64" >> ${OUT}
538 else
539 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
540 exit 1
543 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
544 # double is commented by -fdump-go-spec.
545 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
546 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
548 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
549 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
552 # The time_t type.
553 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
554 echo 'type Time_t _time_t' >> ${OUT}
557 # The time structures need special handling: we need to name the
558 # types, so that we can cast integers to the right types when
559 # assigning to the structures.
560 timeval=`grep '^type _timeval ' gen-sysinfo.go`
561 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
562 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
563 echo "type Timeval_sec_t $timeval_sec" >> ${OUT}
564 echo "type Timeval_usec_t $timeval_usec" >> ${OUT}
565 echo $timeval | \
566 sed -e 's/type _timeval /type Timeval /' \
567 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
568 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
569 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
570 if test "$timespec" = ""; then
571 # IRIX 6.5 has __timespec instead.
572 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
574 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
575 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
576 echo "type Timespec_sec_t $timespec_sec" >> ${OUT}
577 echo "type Timespec_nsec_t $timespec_nsec" >> ${OUT}
578 echo $timespec | \
579 sed -e 's/^type ___timespec /type Timespec /' \
580 -e 's/^type _timespec /type Timespec /' \
581 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
582 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
584 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
585 if test "$timestruc" != ""; then
586 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
587 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
588 echo "type Timestruc_sec_t $timestruc_sec" >> ${OUT}
589 echo "type Timestruc_nsec_t $timestruc_nsec" >> ${OUT}
590 echo $timestruc | \
591 sed -e 's/^type _timestruc_t /type Timestruc /' \
592 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
593 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
596 # The tms struct.
597 grep '^type _tms ' gen-sysinfo.go | \
598 sed -e 's/type _tms/type Tms/' \
599 -e 's/tms_utime/Utime/' \
600 -e 's/tms_stime/Stime/' \
601 -e 's/tms_cutime/Cutime/' \
602 -e 's/tms_cstime/Cstime/' \
603 >> ${OUT}
605 # The stat type.
606 # Prefer largefile variant if available.
607 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
608 if test "$stat" != ""; then
609 grep '^type _stat64 ' gen-sysinfo.go
610 else
611 grep '^type _stat ' gen-sysinfo.go
612 fi | sed -e 's/type _stat64/type Stat_t/' \
613 -e 's/type _stat/type Stat_t/' \
614 -e 's/st_dev/Dev/' \
615 -e 's/st_ino/Ino/g' \
616 -e 's/st_nlink/Nlink/' \
617 -e 's/st_mode/Mode/' \
618 -e 's/st_uid/Uid/' \
619 -e 's/st_gid/Gid/' \
620 -e 's/st_rdev/Rdev/' \
621 -e 's/st_size/Size/' \
622 -e 's/st_blksize/Blksize/' \
623 -e 's/st_blocks/Blocks/' \
624 -e 's/st_atim/Atim/' \
625 -e 's/st_mtim/Mtim/' \
626 -e 's/st_ctim/Ctim/' \
627 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
628 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
629 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
630 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
631 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
632 >> ${OUT}
634 # The directory searching types.
635 # Prefer largefile variant if available.
636 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
637 if test "$dirent" != ""; then
638 grep '^type _dirent64 ' gen-sysinfo.go
639 else
640 grep '^type _dirent ' gen-sysinfo.go
641 fi | sed -e 's/type _dirent64/type Dirent/' \
642 -e 's/type _dirent/type Dirent/' \
643 -e 's/d_name \[0+1\]/d_name [0+256]/' \
644 -e 's/d_name/Name/' \
645 -e 's/]int8/]byte/' \
646 -e 's/d_ino/Ino/' \
647 -e 's/d_off/Off/' \
648 -e 's/d_reclen/Reclen/' \
649 -e 's/d_type/Type/' \
650 >> ${OUT}
651 echo "type DIR _DIR" >> ${OUT}
653 # Values for d_type field in dirent.
654 grep '^const _DT_' gen-sysinfo.go |
655 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
657 # The rusage struct.
658 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
659 if test "$rusage" != ""; then
660 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
661 rusage=`echo $rusage | sed -e 's/Godump_[0-9][0-9]* struct {\([^}]*\)};/\1/g'`
662 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
663 rusage=`echo $rusage | sed -e 's/^ *//'`
664 nrusage=
665 while test -n "$rusage"; do
666 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
667 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
668 # Drop the leading ru_, capitalize the next character.
669 field=`echo $field | sed -e 's/^ru_//'`
670 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
671 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
672 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
673 # Fix _timeval _timespec, and _timestruc_t.
674 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
675 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
676 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
677 field="$f$r"
678 nrusage="$nrusage $field;"
679 done
680 echo "type Rusage struct {$nrusage }" >> ${OUT}
681 else
682 echo "type Rusage struct {}" >> ${OUT}
685 # The RUSAGE constants.
686 grep '^const _RUSAGE_' gen-sysinfo.go | \
687 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
689 # The utsname struct.
690 grep '^type _utsname ' gen-sysinfo.go | \
691 sed -e 's/_utsname/Utsname/' \
692 -e 's/sysname/Sysname/' \
693 -e 's/nodename/Nodename/' \
694 -e 's/release/Release/' \
695 -e 's/version/Version/' \
696 -e 's/machine/Machine/' \
697 -e 's/domainname/Domainname/' \
698 >> ${OUT}
700 # The iovec struct.
701 iovec=`grep '^type _iovec ' gen-sysinfo.go`
702 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
703 echo "type Iovec_len_t $iovec_len" >> ${OUT}
704 echo $iovec | \
705 sed -e 's/_iovec/Iovec/' \
706 -e 's/iov_base/Base/' \
707 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
708 >> ${OUT}
710 # The msghdr struct.
711 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
712 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
713 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
714 echo $msghdr | \
715 sed -e 's/_msghdr/Msghdr/' \
716 -e 's/msg_name/Name/' \
717 -e 's/msg_namelen/Namelen/' \
718 -e 's/msg_iov/Iov/' \
719 -e 's/msg_iovlen/Iovlen/' \
720 -e 's/_iovec/Iovec/' \
721 -e 's/msg_control/Control/' \
722 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
723 -e 's/msg_flags/Flags/' \
724 >> ${OUT}
726 # The MSG_ flags for Msghdr.
727 grep '^const _MSG_' gen-sysinfo.go | \
728 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
730 # The cmsghdr struct.
731 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
732 if test -n "$cmsghdr"; then
733 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
734 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
735 echo "$cmsghdr" | \
736 sed -e 's/_cmsghdr/Cmsghdr/' \
737 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
738 -e 's/cmsg_level/Level/' \
739 -e 's/cmsg_type/Type/' \
740 -e 's/\[\]/[0]/' \
741 >> ${OUT}
744 # The SCM_ flags for Cmsghdr.
745 grep '^const _SCM_' gen-sysinfo.go | \
746 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
748 # The ucred struct.
749 upcase_fields "_ucred" "Ucred" >> ${OUT} || true
751 # The ip_mreq struct.
752 grep '^type _ip_mreq ' gen-sysinfo.go | \
753 sed -e 's/_ip_mreq/IPMreq/' \
754 -e 's/imr_multiaddr/Multiaddr/' \
755 -e 's/imr_interface/Interface/' \
756 -e 's/_in_addr/[4]byte/g' \
757 >> ${OUT}
759 # We need IPMreq to compile the net package.
760 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
761 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
764 # The ipv6_mreq struct.
765 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
766 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
767 -e 's/ipv6mr_multiaddr/Multiaddr/' \
768 -e 's/ipv6mr_interface/Interface/' \
769 -e 's/_in6_addr/[16]byte/' \
770 >> ${OUT}
772 # We need IPv6Mreq to compile the net package.
773 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
774 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
777 # The ip_mreqn struct.
778 grep '^type _ip_mreqn ' gen-sysinfo.go | \
779 sed -e 's/_ip_mreqn/IPMreqn/' \
780 -e 's/imr_multiaddr/Multiaddr/' \
781 -e 's/imr_address/Address/' \
782 -e 's/imr_ifindex/Ifindex/' \
783 -e 's/_in_addr/[4]byte/g' \
784 >> ${OUT}
786 # We need IPMreq to compile the net package.
787 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
788 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
791 # The icmp6_filter struct.
792 grep '^type _icmp6_filter ' gen-sysinfo.go | \
793 sed -e 's/_icmp6_filter/ICMPv6Filter/' \
794 -e 's/data/Data/' \
795 -e 's/filt/Filt/' \
796 >> ${OUT}
798 # We need ICMPv6Filter to compile the syscall package.
799 if ! grep 'type ICMPv6Filter ' ${OUT} > /dev/null 2>&1; then
800 echo 'type ICMPv6Filter struct { Data [8]uint32 }' >> ${OUT}
803 # Try to guess the type to use for fd_set.
804 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
805 fds_bits_type="_C_long"
806 if test "$fd_set" != ""; then
807 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
809 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
811 # The addrinfo struct.
812 grep '^type _addrinfo ' gen-sysinfo.go | \
813 sed -e 's/_addrinfo/Addrinfo/g' \
814 -e 's/ ai_/ Ai_/g' \
815 >> ${OUT}
817 # The addrinfo flags and errors.
818 grep '^const _AI_' gen-sysinfo.go | \
819 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
820 grep '^const _EAI_' gen-sysinfo.go | \
821 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
823 # The passwd struct.
824 grep '^type _passwd ' gen-sysinfo.go | \
825 sed -e 's/_passwd/Passwd/' \
826 -e 's/ pw_/ Pw_/g' \
827 >> ${OUT}
829 # The ioctl flags for the controlling TTY.
830 grep '^const _TIOC' gen-sysinfo.go | \
831 grep -v '_val =' | \
832 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
833 # We need TIOCGWINSZ.
834 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
835 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
836 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
839 if ! grep '^const TIOCSWINSZ' ${OUT} >/dev/null 2>&1; then
840 if grep '^const _TIOCSWINSZ_val' ${OUT} >/dev/null 2>&1; then
841 echo 'const TIOCSWINSZ = _TIOCSWINSZ_val' >> ${OUT}
844 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
845 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
846 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
849 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
850 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
851 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
854 if ! grep '^const TIOCGPTN' ${OUT} >/dev/null 2>&1; then
855 if grep '^const _TIOCGPTN_val' ${OUT} >/dev/null 2>&1; then
856 echo 'const TIOCGPTN = _TIOCGPTN_val' >> ${OUT}
859 if ! grep '^const TIOCSPTLCK' ${OUT} >/dev/null 2>&1; then
860 if grep '^const _TIOCSPTLCK_val' ${OUT} >/dev/null 2>&1; then
861 echo 'const TIOCSPTLCK = _TIOCSPTLCK_val' >> ${OUT}
864 if ! grep '^const TIOCGDEV' ${OUT} >/dev/null 2>&1; then
865 if grep '^const _TIOCGDEV_val' ${OUT} >/dev/null 2>&1; then
866 echo 'const TIOCGDEV = _TIOCGDEV_val' >> ${OUT}
869 if ! grep '^const TIOCSIG' ${OUT} >/dev/null 2>&1; then
870 if grep '^const _TIOCSIG_val' ${OUT} >/dev/null 2>&1; then
871 echo 'const TIOCSIG = _TIOCSIG_val' >> ${OUT}
875 # The ioctl flags for terminal control
876 grep '^const _TC[GS]ET' gen-sysinfo.go | grep -v _val | \
877 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
878 if ! grep '^const TCGETS' ${OUT} >/dev/null 2>&1; then
879 if grep '^const _TCGETS_val' ${OUT} >/dev/null 2>&1; then
880 echo 'const TCGETS = _TCGETS_val' >> ${OUT}
883 if ! grep '^const TCSETS' ${OUT} >/dev/null 2>&1; then
884 if grep '^const _TCSETS_val' ${OUT} >/dev/null 2>&1; then
885 echo 'const TCSETS = _TCSETS_val' >> ${OUT}
889 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
890 # needs handling in syscalls.exec.go.
891 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
892 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
893 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
897 # The nlmsghdr struct.
898 grep '^type _nlmsghdr ' gen-sysinfo.go | \
899 sed -e 's/_nlmsghdr/NlMsghdr/' \
900 -e 's/nlmsg_len/Len/' \
901 -e 's/nlmsg_type/Type/' \
902 -e 's/nlmsg_flags/Flags/' \
903 -e 's/nlmsg_seq/Seq/' \
904 -e 's/nlmsg_pid/Pid/' \
905 >> ${OUT}
907 # The nlmsg flags and operators.
908 grep '^const _NLM' gen-sysinfo.go | \
909 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
911 # NLMSG_HDRLEN is defined as an expression using sizeof.
912 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
913 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
914 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
918 # The rtmsg struct.
919 grep '^type _rtmsg ' gen-sysinfo.go | \
920 sed -e 's/_rtmsg/RtMsg/' \
921 -e 's/rtm_family/Family/' \
922 -e 's/rtm_dst_len/Dst_len/' \
923 -e 's/rtm_src_len/Src_len/' \
924 -e 's/rtm_tos/Tos/' \
925 -e 's/rtm_table/Table/' \
926 -e 's/rtm_protocol/Protocol/' \
927 -e 's/rtm_scope/Scope/' \
928 -e 's/rtm_type/Type/' \
929 -e 's/rtm_flags/Flags/' \
930 >> ${OUT}
932 # The rtgenmsg struct.
933 grep '^type _rtgenmsg ' gen-sysinfo.go | \
934 sed -e 's/_rtgenmsg/RtGenmsg/' \
935 -e 's/rtgen_family/Family/' \
936 >> ${OUT}
938 # The routing message flags.
939 grep '^const _RT_' gen-sysinfo.go | \
940 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
941 grep '^const _RTA' gen-sysinfo.go | \
942 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
943 grep '^const _RTF' gen-sysinfo.go | \
944 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
945 grep '^const _RTCF' gen-sysinfo.go | \
946 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
947 grep '^const _RTM' gen-sysinfo.go | \
948 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
949 grep '^const _RTN' gen-sysinfo.go | \
950 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
951 grep '^const _RTPROT' gen-sysinfo.go | \
952 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
954 # The ifinfomsg struct.
955 grep '^type _ifinfomsg ' gen-sysinfo.go | \
956 sed -e 's/_ifinfomsg/IfInfomsg/' \
957 -e 's/ifi_family/Family/' \
958 -e 's/ifi_type/Type/' \
959 -e 's/ifi_index/Index/' \
960 -e 's/ifi_flags/Flags/' \
961 -e 's/ifi_change/Change/' \
962 >> ${OUT}
964 # The interface information types and flags.
965 grep '^const _IFA' gen-sysinfo.go | \
966 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
967 grep '^const _IFLA' gen-sysinfo.go | \
968 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
969 grep '^const _IFF' gen-sysinfo.go | \
970 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
971 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
972 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
973 grep '^const _SIOC' gen-sysinfo.go |
974 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
976 # The ifaddrmsg struct.
977 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
978 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
979 -e 's/ifa_family/Family/' \
980 -e 's/ifa_prefixlen/Prefixlen/' \
981 -e 's/ifa_flags/Flags/' \
982 -e 's/ifa_scope/Scope/' \
983 -e 's/ifa_index/Index/' \
984 >> ${OUT}
986 # The rtattr struct.
987 grep '^type _rtattr ' gen-sysinfo.go | \
988 sed -e 's/_rtattr/RtAttr/' \
989 -e 's/rta_len/Len/' \
990 -e 's/rta_type/Type/' \
991 >> ${OUT}
993 # The in_pktinfo struct.
994 grep '^type _in_pktinfo ' gen-sysinfo.go | \
995 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
996 -e 's/ipi_ifindex/Ifindex/' \
997 -e 's/ipi_spec_dst/Spec_dst/' \
998 -e 's/ipi_addr/Addr/' \
999 -e 's/_in_addr/[4]byte/g' \
1000 >> ${OUT}
1002 # The in6_pktinfo struct.
1003 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
1004 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
1005 -e 's/ipi6_addr/Addr/' \
1006 -e 's/ipi6_ifindex/Ifindex/' \
1007 -e 's/_in6_addr/[16]byte/' \
1008 >> ${OUT}
1010 # The termios struct.
1011 grep '^type _termios ' gen-sysinfo.go | \
1012 sed -e 's/_termios/Termios/' \
1013 -e 's/c_iflag/Iflag/' \
1014 -e 's/c_oflag/Oflag/' \
1015 -e 's/c_cflag/Cflag/' \
1016 -e 's/c_lflag/Lflag/' \
1017 -e 's/c_line/Line/' \
1018 -e 's/c_cc/Cc/' \
1019 -e 's/c_ispeed/Ispeed/' \
1020 -e 's/c_ospeed/Ospeed/' \
1021 >> ${OUT}
1023 # The termios constants.
1024 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
1025 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
1026 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
1027 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
1028 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
1029 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
1030 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
1031 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
1032 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
1033 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
1034 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
1035 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
1037 grep "^const _$n " gen-sysinfo.go | \
1038 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1039 done
1041 # The mount flags
1042 grep '^const _MNT_' gen-sysinfo.go |
1043 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1044 grep '^const _MS_' gen-sysinfo.go |
1045 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1047 # The fallocate flags.
1048 grep '^const _FALLOC_' gen-sysinfo.go |
1049 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1051 # The statfs struct.
1052 # Prefer largefile variant if available.
1053 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
1054 if test "$statfs" != ""; then
1055 grep '^type _statfs64 ' gen-sysinfo.go
1056 else
1057 grep '^type _statfs ' gen-sysinfo.go
1058 fi | sed -e 's/type _statfs64/type Statfs_t/' \
1059 -e 's/type _statfs/type Statfs_t/' \
1060 -e 's/f_type/Type/' \
1061 -e 's/f_bsize/Bsize/' \
1062 -e 's/f_blocks/Blocks/' \
1063 -e 's/f_bfree/Bfree/' \
1064 -e 's/f_bavail/Bavail/' \
1065 -e 's/f_files/Files/' \
1066 -e 's/f_ffree/Ffree/' \
1067 -e 's/f_fsid/Fsid/' \
1068 -e 's/f_namelen/Namelen/' \
1069 -e 's/f_frsize/Frsize/' \
1070 -e 's/f_flags/Flags/' \
1071 -e 's/f_spare/Spare/' \
1072 >> ${OUT}
1074 # The timex struct.
1075 timex=`grep '^type _timex ' gen-sysinfo.go || true`
1076 if test "$timex" = ""; then
1077 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
1078 if test "$timex" != ""; then
1079 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
1082 if test "$timex" != ""; then
1083 echo "$timex" | \
1084 sed -e 's/_timex/Timex/' \
1085 -e 's/modes/Modes/' \
1086 -e 's/offset/Offset/' \
1087 -e 's/freq/Freq/' \
1088 -e 's/maxerror/Maxerror/' \
1089 -e 's/esterror/Esterror/' \
1090 -e 's/status/Status/' \
1091 -e 's/constant/Constant/' \
1092 -e 's/precision/Precision/' \
1093 -e 's/tolerance/Tolerance/' \
1094 -e 's/ time / Time /' \
1095 -e 's/tick/Tick/' \
1096 -e 's/ppsfreq/Ppsfreq/' \
1097 -e 's/jitter/Jitter/' \
1098 -e 's/shift/Shift/' \
1099 -e 's/stabil/Stabil/' \
1100 -e 's/jitcnt/Jitcnt/' \
1101 -e 's/calcnt/Calcnt/' \
1102 -e 's/errcnt/Errcnt/' \
1103 -e 's/stbcnt/Stbcnt/' \
1104 -e 's/tai/Tai/' \
1105 -e 's/_timeval/Timeval/' \
1106 >> ${OUT}
1109 # The rlimit struct.
1110 grep '^type _rlimit ' gen-sysinfo.go | \
1111 sed -e 's/_rlimit/Rlimit/' \
1112 -e 's/rlim_cur/Cur/' \
1113 -e 's/rlim_max/Max/' \
1114 >> ${OUT}
1116 # The RLIMIT constants.
1117 grep '^const _RLIMIT_' gen-sysinfo.go |
1118 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1119 grep '^const _RLIM_' gen-sysinfo.go |
1120 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1122 # The sysinfo struct.
1123 grep '^type _sysinfo ' gen-sysinfo.go | \
1124 sed -e 's/_sysinfo/Sysinfo_t/' \
1125 -e 's/uptime/Uptime/' \
1126 -e 's/loads/Loads/' \
1127 -e 's/totalram/Totalram/' \
1128 -e 's/freeram/Freeram/' \
1129 -e 's/sharedram/Sharedram/' \
1130 -e 's/bufferram/Bufferram/' \
1131 -e 's/totalswap/Totalswap/' \
1132 -e 's/freeswap/Freeswap/' \
1133 -e 's/procs/Procs/' \
1134 -e 's/totalhigh/Totalhigh/' \
1135 -e 's/freehigh/Freehigh/' \
1136 -e 's/mem_unit/Unit/' \
1137 >> ${OUT}
1139 # The ustat struct.
1140 grep '^type _ustat ' gen-sysinfo.go | \
1141 sed -e 's/_ustat/Ustat_t/' \
1142 -e 's/f_tfree/Tfree/' \
1143 -e 's/f_tinode/Tinoe/' \
1144 -e 's/f_fname/Fname/' \
1145 -e 's/f_fpack/Fpack/' \
1146 >> ${OUT}
1147 # Force it to be defined, as on some older GNU/Linux systems the
1148 # header file fails when using with <linux/filter.h>.
1149 if ! grep 'type _ustat ' gen-sysinfo.go >/dev/null 2>&1; then
1150 echo 'type Ustat_t struct { Tfree int32; Tinoe uint64; Fname [5+1]int8; Fpack [5+1]int8; }' >> ${OUT}
1153 # The utimbuf struct.
1154 grep '^type _utimbuf ' gen-sysinfo.go | \
1155 sed -e 's/_utimbuf/Utimbuf/' \
1156 -e 's/actime/Actime/' \
1157 -e 's/modtime/Modtime/' \
1158 >> ${OUT}
1160 # The LOCK flags for flock.
1161 grep '^const _LOCK_' gen-sysinfo.go |
1162 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1164 # The PRIO constants.
1165 grep '^const _PRIO_' gen-sysinfo.go | \
1166 sed -e 's/^\(const \)_\(PRIO_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1168 # The GNU/Linux LINUX_REBOOT flags.
1169 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1170 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1172 # The GNU/Linux sock_filter struct.
1173 grep '^type _sock_filter ' gen-sysinfo.go | \
1174 sed -e 's/_sock_filter/SockFilter/' \
1175 -e 's/code/Code/' \
1176 -e 's/jt/Jt/' \
1177 -e 's/jf/Jf/' \
1178 -e 's/k /K /' \
1179 >> ${OUT}
1181 # The GNU/Linux sock_fprog struct.
1182 grep '^type _sock_fprog ' gen-sysinfo.go | \
1183 sed -e 's/_sock_fprog/SockFprog/' \
1184 -e 's/len/Len/' \
1185 -e 's/filter/Filter/' \
1186 -e 's/_sock_filter/SockFilter/' \
1187 >> ${OUT}
1189 # The GNU/Linux filter flags.
1190 grep '^const _BPF_' gen-sysinfo.go | \
1191 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1193 # The GNU/Linux nlattr struct.
1194 grep '^type _nlattr ' gen-sysinfo.go | \
1195 sed -e 's/_nlattr/NlAttr/' \
1196 -e 's/nla_len/Len/' \
1197 -e 's/nla_type/Type/' \
1198 >> ${OUT}
1200 # The GNU/Linux nlmsgerr struct.
1201 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1202 sed -e 's/_nlmsgerr/NlMsgerr/' \
1203 -e 's/error/Error/' \
1204 -e 's/msg/Msg/' \
1205 -e 's/_nlmsghdr/NlMsghdr/' \
1206 >> ${OUT}
1208 # The GNU/Linux rtnexthop struct.
1209 grep '^type _rtnexthop ' gen-sysinfo.go | \
1210 sed -e 's/_rtnexthop/RtNexthop/' \
1211 -e 's/rtnh_len/Len/' \
1212 -e 's/rtnh_flags/Flags/' \
1213 -e 's/rtnh_hops/Hops/' \
1214 -e 's/rtnh_ifindex/Ifindex/' \
1215 >> ${OUT}
1217 # The GNU/Linux netlink flags.
1218 grep '^const _NETLINK_' gen-sysinfo.go | \
1219 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1220 grep '^const _NLA_' gen-sysinfo.go | \
1221 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1223 # The GNU/Linux packet socket flags.
1224 grep '^const _PACKET_' gen-sysinfo.go | \
1225 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1227 # The GNU/Linux inotify_event struct.
1228 grep '^type _inotify_event ' gen-sysinfo.go | \
1229 sed -e 's/_inotify_event/InotifyEvent/' \
1230 -e 's/wd/Wd/' \
1231 -e 's/mask/Mask/' \
1232 -e 's/cookie/Cookie/' \
1233 -e 's/len/Len/' \
1234 -e 's/name/Name/' \
1235 -e 's/\[\]/[0]/' \
1236 -e 's/\[0\]byte/[0]int8/' \
1237 >> ${OUT}
1239 # The GNU/Linux CLONE flags.
1240 grep '^const _CLONE_' gen-sysinfo.go | \
1241 sed -e 's/^\(const \)_\(CLONE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1243 # Struct sizes.
1244 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1245 ifaddrmsg IfAddrmsg ifinfomsg IfInfomsg in_pktinfo Inet4Pktinfo \
1246 in6_pktinfo Inet6Pktinfo inotify_event InotifyEvent linger Linger \
1247 msghdr Msghdr nlattr NlAttr nlmsgerr NlMsgerr nlmsghdr NlMsghdr \
1248 rtattr RtAttr rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1249 sock_filter SockFilter sock_fprog SockFprog ucred Ucred \
1250 icmp6_filter ICMPv6Filter
1251 while test $# != 0; do
1252 nc=$1
1253 ngo=$2
1254 shift
1255 shift
1256 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1257 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1259 done
1261 # In order to compile the net package, we need some sizes to exist
1262 # even if the types do not.
1263 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1264 echo 'const SizeofIPMreq = 8' >> ${OUT}
1266 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1267 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1269 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1270 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1272 if ! grep 'const SizeofICMPv6Filter ' ${OUT} >/dev/null 2>&1; then
1273 echo 'const SizeofICMPv6Filter = 32' >> ${OUT}
1276 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1277 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1278 sed -e 's/_in6_addr/[16]byte/' \
1279 >> ${OUT}
1281 exit $?